Index: branches/HTM-9.0-dev0/source/Lib/TLibDecoder/TDecTop.cpp
===================================================================
--- branches/HTM-9.0-dev0/source/Lib/TLibDecoder/TDecTop.cpp	(revision 729)
+++ branches/HTM-9.0-dev0/source/Lib/TLibDecoder/TDecTop.cpp	(revision 730)
@@ -635,4 +635,10 @@
 #if H_MV
   m_apcSlicePilot->setVPS(vps);  
+#if H_MV_6_PS_0092_17
+  // The nuh_layer_id value of the NAL unit containing the PPS that is activated for a layer layerA with nuh_layer_id equal to nuhLayerIdA shall be equal to 0, or nuhLayerIdA, or the nuh_layer_id of a direct or indirect reference layer of layerA.
+  assert( pps->getLayerId() == m_layerId || pps->getLayerId( ) == 0 || vps->getInDirectDependencyFlag( m_layerId, pps->getLayerId() ) );   
+  // The nuh_layer_id value of the NAL unit containing the SPS that is activated for a layer layerA with nuh_layer_id equal to nuhLayerIdA shall be equal to 0, or nuhLayerIdA, or the nuh_layer_id of a direct or indirect reference layer of layerA.
+  assert( sps->getLayerId() == m_layerId || sps->getLayerId( ) == 0 || vps->getInDirectDependencyFlag( m_layerId, sps->getLayerId() ) );
+#endif
   sps->inferRepFormat  ( vps , m_layerId ); 
   sps->inferScalingList( m_parameterSetManagerDecoder.getActiveSPS( sps->getSpsScalingListRefLayerId() ) ); 
@@ -665,8 +671,11 @@
 
 #if H_MV
+#if H_MV_FIX_SKIP_PICTURES
+Bool TDecTop::xDecodeSlice(InputNALUnit &nalu, Int &iSkipFrame, Int iPOCLastDisplay, Bool newLayerFlag, Bool& sliceSkippedFlag  )
+#else
 Bool TDecTop::xDecodeSlice(InputNALUnit &nalu, Int &iSkipFrame, Int iPOCLastDisplay, Bool newLayerFlag )
+#endif
 {
   assert( nalu.m_layerId == m_layerId ); 
-
 #else
 Bool TDecTop::xDecodeSlice(InputNALUnit &nalu, Int &iSkipFrame, Int iPOCLastDisplay )
@@ -722,9 +731,16 @@
 #endif
 #endif
+
+#if H_MV_LAYER_WISE_STARTUP
+    xCeckNoClrasOutput();
+#endif
     // Skip pictures due to random access
     if (isRandomAccessSkipPicture(iSkipFrame, iPOCLastDisplay))
     {
-    m_prevSliceSkipped = true;
-    m_skippedPOC = m_apcSlicePilot->getPOC();
+      m_prevSliceSkipped = true;
+      m_skippedPOC = m_apcSlicePilot->getPOC();
+#if H_MV_FIX_SKIP_PICTURES
+      sliceSkippedFlag = true; 
+#endif
       return false;
     }
@@ -732,6 +748,9 @@
     if (isSkipPictureForBLA(iPOCLastDisplay))
     {
-    m_prevSliceSkipped = true;
-    m_skippedPOC = m_apcSlicePilot->getPOC();
+      m_prevSliceSkipped = true;
+      m_skippedPOC = m_apcSlicePilot->getPOC();
+#if H_MV_FIX_SKIP_PICTURES
+      sliceSkippedFlag = true; 
+#endif
       return false;
     }
@@ -788,4 +807,5 @@
     xCreateLostPicture(lostPoc-1);
   }
+  
   if (m_bFirstSliceInPicture)
   {
@@ -1171,5 +1191,9 @@
 
 #if H_MV
+#if H_MV_FIX_SKIP_PICTURES
+Bool TDecTop::decode(InputNALUnit& nalu, Int& iSkipFrame, Int& iPOCLastDisplay, Bool newLayerFlag, Bool& sliceSkippedFlag )
+#else
 Bool TDecTop::decode(InputNALUnit& nalu, Int& iSkipFrame, Int& iPOCLastDisplay, Bool newLayerFlag)
+#endif
 #else
 Bool TDecTop::decode(InputNALUnit& nalu, Int& iSkipFrame, Int& iPOCLastDisplay)
@@ -1216,5 +1240,9 @@
     case NAL_UNIT_CODED_SLICE_RASL_R:
 #if H_MV
+#if H_MV_FIX_SKIP_PICTURES
+      return xDecodeSlice(nalu, iSkipFrame, iPOCLastDisplay, newLayerFlag, sliceSkippedFlag );
+#else
       return xDecodeSlice(nalu, iSkipFrame, iPOCLastDisplay, newLayerFlag);
+#endif
 #else
       return xDecodeSlice(nalu, iSkipFrame, iPOCLastDisplay);
@@ -1242,4 +1270,5 @@
     return true;
   }
+
   return false;
 }
@@ -1265,5 +1294,9 @@
     return true;
   }
+#if H_MV_LAYER_WISE_STARTUP
+  else if ( !m_layerInitilizedFlag[ m_layerId ] ) // start of random access point, m_pocRandomAccess has not been set yet.
+#else
   else if (m_pocRandomAccess == MAX_INT) // start of random access point, m_pocRandomAccess has not been set yet.
+#endif
   {
     if (   m_apcSlicePilot->getNalUnitType() == NAL_UNIT_CODED_SLICE_CRA
@@ -1272,13 +1305,57 @@
         || m_apcSlicePilot->getNalUnitType() == NAL_UNIT_CODED_SLICE_BLA_W_RADL )
     {
+
+#if H_MV_LAYER_WISE_STARTUP
+      if ( xAllRefLayersInitilized() )
+      {
+        m_layerInitilizedFlag[ m_layerId ] = true; 
+        m_pocRandomAccess = m_apcSlicePilot->getPOC();
+      }
+      else
+      {
+        return true; 
+      }
+#else
       // set the POC random access since we need to skip the reordered pictures in the case of CRA/CRANT/BLA/BLANT.
       m_pocRandomAccess = m_apcSlicePilot->getPOC();
+#endif
     }
     else if ( m_apcSlicePilot->getNalUnitType() == NAL_UNIT_CODED_SLICE_IDR_W_RADL || m_apcSlicePilot->getNalUnitType() == NAL_UNIT_CODED_SLICE_IDR_N_LP )
     {
+#if H_MV_LAYER_WISE_STARTUP
+      if ( xAllRefLayersInitilized() )
+      {
+        m_layerInitilizedFlag[ m_layerId ] = true; 
+        m_pocRandomAccess = -MAX_INT; // no need to skip the reordered pictures in IDR, they are decodable.
+      }
+      else
+      {
+        return true; 
+      }
+#else
       m_pocRandomAccess = -MAX_INT; // no need to skip the reordered pictures in IDR, they are decodable.
+#endif
     }
     else 
     {
+#if H_MV_FIX_SKIP_PICTURES
+      static Bool warningMessage[MAX_NUM_LAYERS];
+      static Bool warningInitFlag = false;
+      
+      if (!warningInitFlag)
+      {
+        for ( Int i = 0; i < MAX_NUM_LAYERS; i++)
+        {
+          warningMessage[i] = true; 
+        }
+        warningInitFlag = true; 
+      }
+
+      if ( warningMessage[getLayerId()] )
+      {
+        printf("\nLayer%3d   No valid random access point. VCL NAL units of this layer are discarded until next layer initialization picture. ", getLayerId() ); 
+        warningMessage[m_layerId] = false; 
+      }
+#else
       static Bool warningMessage = false;
       if(!warningMessage)
@@ -1287,4 +1364,5 @@
         warningMessage = true;
       }
+#endif
       return true;
     }
@@ -1296,6 +1374,10 @@
     return true;
   }
+#if H_MV_LAYER_WISE_STARTUP
+  return !m_layerInitilizedFlag[ getLayerId() ]; 
+#else
   // if we reach here, then the picture is not skipped.
   return false; 
+#endif
 }
 
@@ -1338,4 +1420,40 @@
   }
 }
+
+#if H_MV_LAYER_WISE_STARTUP
+Void TDecTop::xCeckNoClrasOutput()
+{
+  // This part needs further testing! 
+  if ( getLayerId() == 0 )
+  {    
+    NalUnitType nut = m_apcSlicePilot->getNalUnitType(); 
+
+    Bool isBLA =  ( nut == NAL_UNIT_CODED_SLICE_BLA_W_LP  )  || ( nut == NAL_UNIT_CODED_SLICE_BLA_N_LP ) || ( nut == NAL_UNIT_CODED_SLICE_BLA_W_RADL ); 
+    Bool isIDR  = ( nut == NAL_UNIT_CODED_SLICE_IDR_W_RADL ) || ( nut == NAL_UNIT_CODED_SLICE_IDR_N_LP ); 
+    Bool noClrasOutputFlag  = isBLA || ( isIDR  &&  m_apcSlicePilot->getCrossLayerBlaFlag() ); 
+
+    if ( noClrasOutputFlag ) 
+    {
+      for (Int i = 0; i < MAX_NUM_LAYER_IDS; i++)
+      {
+        m_layerInitilizedFlag[i] = false; 
+      } 
+    }
+  }
+}
+
+Bool TDecTop::xAllRefLayersInitilized()
+{
+  Bool allRefLayersInitilizedFlag = true; 
+  TComVPS* vps = m_parameterSetManagerDecoder.getPrefetchedVPS( 0 ); 
+  for (Int i = 0; i < vps->getNumDirectRefLayers( getLayerId()  ); i++ )
+  {
+    Int refLayerId = vps->getRefLayerId( m_layerId, i ); 
+    allRefLayersInitilizedFlag = allRefLayersInitilizedFlag && m_layerInitilizedFlag[ refLayerId ]; 
+  }
+
+  return allRefLayersInitilizedFlag;
+}
+#endif
 #endif
 //! \}
Index: branches/HTM-9.0-dev0/source/Lib/TLibDecoder/TDecTop.h
===================================================================
--- branches/HTM-9.0-dev0/source/Lib/TLibDecoder/TDecTop.h	(revision 729)
+++ branches/HTM-9.0-dev0/source/Lib/TLibDecoder/TDecTop.h	(revision 730)
@@ -186,4 +186,7 @@
   TComList<TComPic*>      m_cListPic;         //  Dynamic buffer
 #if H_MV
+#if H_MV_LAYER_WISE_STARTUP
+  Bool*                    m_layerInitilizedFlag; // initialization Layers
+#endif
   static ParameterSetManagerDecoder m_parameterSetManagerDecoder;  // storage for parameter sets 
 #else
@@ -243,4 +246,9 @@
   Void  init();
 #if H_MV  
+#if H_MV_FIX_SKIP_PICTURES
+  Bool  decode(InputNALUnit& nalu, Int& iSkipFrame, Int& iPOCLastDisplay, Bool newLayer, Bool& sliceSkippedFlag );
+#else
+  Bool  decode(InputNALUnit& nalu, Int& iSkipFrame, Int& iPOCLastDisplay, Bool newLayer );
+#endif
   Bool  decode(InputNALUnit& nalu, Int& iSkipFrame, Int& iPOCLastDisplay, Bool newLayer );
 #else  
@@ -260,5 +268,10 @@
   TComList<TComPic*>*     getListPic            ()               { return &m_cListPic;  }  
   Void                    setIvPicLists         ( TComPicLists* picLists) { m_ivPicLists = picLists; }
-  
+#if H_MV_LAYER_WISE_STARTUP
+  Void                    setLayerInitilizedFlags( Bool* val )    { m_layerInitilizedFlag = val; }
+#endif
+#if H_MV_6_HRD_O0217_13
+  TComVPS*                getPrefetchedVPS      ()               { return m_parameterSetManagerDecoder.getPrefetchedVPS( 0 ); }; //Assuming that currently only one VPS is present. 
+#endif
   Int                     getCurrPoc            ()               { return m_apcSlicePilot->getPOC(); }
   Void                    setLayerId            ( Int layer)     { m_layerId = layer;   }
@@ -281,6 +294,15 @@
 #if H_MV  
   TComPic*  xGetPic( Int layerId, Int poc ); 
+#if H_MV_FIX_SKIP_PICTURES
+  Bool      xDecodeSlice(InputNALUnit &nalu, Int &iSkipFrame, Int iPOCLastDisplay, Bool newLayerFlag, Bool& sliceSkippedFlag );  
+#else
   Bool      xDecodeSlice(InputNALUnit &nalu, Int &iSkipFrame, Int iPOCLastDisplay, Bool newLayerFlag );  
+#endif
   Void      xResetPocInPicBuffer();
+#if H_MV_LAYER_WISE_STARTUP
+  Void      xCeckNoClrasOutput();
+
+  Bool      xAllRefLayersInitilized();
+#endif
 #else
   Bool      xDecodeSlice(InputNALUnit &nalu, Int &iSkipFrame, Int iPOCLastDisplay);
@@ -291,4 +313,5 @@
   Void      xDecodeSEI( TComInputBitstream* bs, const NalUnitType nalUnitType );
 
+
 };// END CLASS DEFINITION TDecTop
 
